git-stash.sh 6.58 KB
Newer Older
しらいしななこ's avatar
しらいしななこ committed
1 2 3
#!/bin/sh
# Copyright (c) 2007, Nanako Shiraishi

4 5 6 7 8 9 10
dashless=$(basename "$0" | sed -e 's/-/ /')
USAGE="list [<options>]
   or: $dashless (show | drop | pop ) [<stash>]
   or: $dashless apply [--index] [<stash>]
   or: $dashless branch <branchname> [<stash>]
   or: $dashless [save [--keep-index] [<message>]]
   or: $dashless clear"
しらいしななこ's avatar
しらいしななこ committed
11

12
SUBDIRECTORY_OK=Yes
13
OPTIONS_SPEC=
しらいしななこ's avatar
しらいしななこ committed
14 15
. git-sh-setup
require_work_tree
16
cd_to_toplevel
しらいしななこ's avatar
しらいしななこ committed
17 18 19 20 21 22 23

TMP="$GIT_DIR/.git-stash.$$"
trap 'rm -f "$TMP-*"' 0

ref_stash=refs/stash

no_changes () {
24 25
	git diff-index --quiet --cached HEAD --ignore-submodules -- &&
	git diff-files --quiet --ignore-submodules
しらいしななこ's avatar
しらいしななこ committed
26 27 28
}

clear_stash () {
29 30 31 32
	if test $# != 0
	then
		die "git stash clear with parameters is unimplemented"
	fi
33 34
	if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
	then
Emil Medve's avatar
Emil Medve committed
35
		git update-ref -d $ref_stash $current
36
	fi
しらいしななこ's avatar
しらいしななこ committed
37 38
}

39
create_stash () {
40 41
	stash_msg="$1"

42
	git update-index -q --refresh
しらいしななこ's avatar
しらいしななこ committed
43 44 45 46
	if no_changes
	then
		exit 0
	fi
47

しらいしななこ's avatar
しらいしななこ committed
48
	# state of the base commit
49
	if b_commit=$(git rev-parse --verify HEAD)
しらいしななこ's avatar
しらいしななこ committed
50
	then
51
		head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
しらいしななこ's avatar
しらいしななこ committed
52 53 54 55
	else
		die "You do not have the initial commit yet"
	fi

56
	if branch=$(git symbolic-ref -q HEAD)
しらいしななこ's avatar
しらいしななこ committed
57 58 59 60 61 62 63 64
	then
		branch=${branch#refs/heads/}
	else
		branch='(no branch)'
	fi
	msg=$(printf '%s: %s' "$branch" "$head")

	# state of the index
65
	i_tree=$(git write-tree) &&
66
	i_commit=$(printf 'index on %s\n' "$msg" |
67
		git commit-tree $i_tree -p $b_commit) ||
しらいしななこ's avatar
しらいしななこ committed
68 69 70 71
		die "Cannot save the current index state"

	# state of the working tree
	w_tree=$( (
72 73
		rm -f "$TMP-index" &&
		cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
しらいしななこ's avatar
しらいしななこ committed
74 75
		GIT_INDEX_FILE="$TMP-index" &&
		export GIT_INDEX_FILE &&
76
		git read-tree -m $i_tree &&
77 78
		git add -u &&
		git write-tree &&
しらいしななこ's avatar
しらいしななこ committed
79 80 81 82 83
		rm -f "$TMP-index"
	) ) ||
		die "Cannot save the current worktree state"

	# create the stash
84 85 86 87 88 89 90
	if test -z "$stash_msg"
	then
		stash_msg=$(printf 'WIP on %s' "$msg")
	else
		stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
	fi
	w_commit=$(printf '%s\n' "$stash_msg" |
91
		git commit-tree $w_tree -p $b_commit -p $i_commit) ||
しらいしななこ's avatar
しらいしななこ committed
92
		die "Cannot record working tree state"
93
}
しらいしななこ's avatar
しらいしななこ committed
94

95
save_stash () {
96 97 98 99 100 101 102
	keep_index=
	case "$1" in
	--keep-index)
		keep_index=t
		shift
	esac

103
	stash_msg="$*"
104

105
	git update-index -q --refresh
106 107
	if no_changes
	then
108
		echo 'No local changes to save'
109 110 111 112 113 114
		exit 0
	fi
	test -f "$GIT_DIR/logs/$ref_stash" ||
		clear_stash || die "Cannot initialize stash"

	create_stash "$stash_msg"
Emil Medve's avatar
Emil Medve committed
115 116 117

	# Make sure the reflog for stash is kept.
	: >>"$GIT_DIR/logs/$ref_stash"
しらいしななこ's avatar
しらいしななこ committed
118

119
	git update-ref -m "$stash_msg" $ref_stash $w_commit ||
しらいしななこ's avatar
しらいしななこ committed
120
		die "Cannot save the current status"
121
	printf 'Saved working directory and index state "%s"\n' "$stash_msg"
122 123 124 125 126 127 128

	git reset --hard

	if test -n "$keep_index" && test -n $i_tree
	then
		git read-tree --reset -u $i_tree
	fi
しらいしななこ's avatar
しらいしななこ committed
129 130
}

131
have_stash () {
132
	git rev-parse --verify $ref_stash >/dev/null 2>&1
133 134
}

しらいしななこ's avatar
しらいしななこ committed
135
list_stash () {
136
	have_stash || return 0
137
	git log --no-color --pretty=oneline -g "[email protected]" $ref_stash -- |
しらいしななこ's avatar
しらいしななこ committed
138 139 140 141
	sed -n -e 's/^[.0-9a-f]* refs\///p'
}

show_stash () {
142
	flags=$(git rev-parse --no-revs --flags "[email protected]")
しらいしななこ's avatar
しらいしななこ committed
143 144 145 146
	if test -z "$flags"
	then
		flags=--stat
	fi
147
	s=$(git rev-parse --revs-only --no-flags --default $ref_stash "[email protected]")
しらいしななこ's avatar
しらいしななこ committed
148

149 150
	w_commit=$(git rev-parse --verify "$s") &&
	b_commit=$(git rev-parse --verify "$s^") &&
151
	git diff $flags $b_commit $w_commit
しらいしななこ's avatar
しらいしななこ committed
152 153 154
}

apply_stash () {
155
	git update-index -q --refresh &&
156
	git diff-files --quiet --ignore-submodules ||
しらいしななこ's avatar
しらいしななこ committed
157 158
		die 'Cannot restore on top of a dirty state'

159 160 161 162 163 164 165
	unstash_index=
	case "$1" in
	--index)
		unstash_index=t
		shift
	esac

しらいしななこ's avatar
しらいしななこ committed
166
	# current index state
167
	c_tree=$(git write-tree) ||
しらいしななこ's avatar
しらいしななこ committed
168 169
		die 'Cannot apply a stash in the middle of a merge'

Junio C Hamano's avatar
Junio C Hamano committed
170 171
	# stash records the work tree, and is a merge between the
	# base commit (first parent) and the index tree (second parent).
172 173
	s=$(git rev-parse --revs-only --no-flags --default $ref_stash "[email protected]") &&
	w_tree=$(git rev-parse --verify "$s:") &&
Junio C Hamano's avatar
Junio C Hamano committed
174 175
	b_tree=$(git rev-parse --verify "$s^1:") &&
	i_tree=$(git rev-parse --verify "$s^2:") ||
しらいしななこ's avatar
しらいしななこ committed
176 177
		die "$*: no valid stashed state found"

Junio C Hamano's avatar
Junio C Hamano committed
178
	unstashed_index_tree=
179 180
	if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
			test "$c_tree" != "$i_tree"
Junio C Hamano's avatar
Junio C Hamano committed
181
	then
182
		git diff-tree --binary $s^2^..$s^2 | git apply --cached
183 184 185 186 187
		test $? -ne 0 &&
			die 'Conflicts in index. Try without --index.'
		unstashed_index_tree=$(git-write-tree) ||
			die 'Could not save index tree'
		git reset
Junio C Hamano's avatar
Junio C Hamano committed
188
	fi
189

しらいしななこ's avatar
しらいしななこ committed
190 191 192 193 194 195 196 197 198 199
	eval "
		GITHEAD_$w_tree='Stashed changes' &&
		GITHEAD_$c_tree='Updated upstream' &&
		GITHEAD_$b_tree='Version stash was based on' &&
		export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
	"

	if git-merge-recursive $b_tree -- $c_tree $w_tree
	then
		# No conflict
Junio C Hamano's avatar
Junio C Hamano committed
200 201 202
		if test -n "$unstashed_index_tree"
		then
			git read-tree "$unstashed_index_tree"
203 204
		else
			a="$TMP-added" &&
205
			git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
206 207 208 209
			git read-tree --reset $c_tree &&
			git update-index --add --stdin <"$a" ||
				die "Cannot unstage modified files"
			rm -f "$a"
Junio C Hamano's avatar
Junio C Hamano committed
210 211
		fi
		git status || :
しらいしななこ's avatar
しらいしななこ committed
212 213
	else
		# Merge conflict; keep the exit status from merge-recursive
214
		status=$?
Junio C Hamano's avatar
Junio C Hamano committed
215 216 217 218
		if test -n "$unstash_index"
		then
			echo >&2 'Index was not unstashed.'
		fi
219
		exit $status
しらいしななこ's avatar
しらいしななこ committed
220 221 222
	fi
}

223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244
drop_stash () {
	have_stash || die 'No stash entries to drop'

	if test $# = 0
	then
		set x "$ref_stash@{0}"
		shift
	fi
	# Verify supplied argument looks like a stash entry
	s=$(git rev-parse --revs-only --no-flags "[email protected]") &&
	git rev-parse --verify "$s:"   > /dev/null 2>&1 &&
	git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
	git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
		die "$*: not a valid stashed state"

	git reflog delete --updateref --rewrite "[email protected]" &&
		echo "Dropped $* ($s)" || die "$*: Could not drop stash entry"

	# clear_stash if we just dropped the last stash entry
	git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
}

245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261
apply_to_branch () {
	have_stash || die 'Nothing to apply'

	test -n "$1" || die 'No branch name specified'
	branch=$1

	if test -z "$2"
	then
		set x "$ref_stash@{0}"
	fi
	stash=$2

	git-checkout -b $branch $stash^ &&
	apply_stash --index $stash &&
	drop_stash $stash
}

しらいしななこ's avatar
しらいしななこ committed
262 263
# Main command set
case "$1" in
264 265
list)
	shift
しらいしななこ's avatar
しらいしななこ committed
266 267 268 269 270 271 272 273 274 275 276
	if test $# = 0
	then
		set x -n 10
		shift
	fi
	list_stash "[email protected]"
	;;
show)
	shift
	show_stash "[email protected]"
	;;
277 278
save)
	shift
279
	save_stash "[email protected]"
280
	;;
しらいしななこ's avatar
しらいしななこ committed
281 282 283 284 285
apply)
	shift
	apply_stash "[email protected]"
	;;
clear)
286 287
	shift
	clear_stash "[email protected]"
しらいしななこ's avatar
しらいしななこ committed
288
	;;
289 290 291 292 293 294 295
create)
	if test $# -gt 0 && test "$1" = create
	then
		shift
	fi
	create_stash "$*" && echo "$w_commit"
	;;
296 297 298 299
drop)
	shift
	drop_stash "[email protected]"
	;;
300 301 302 303 304 305 306 307
pop)
	shift
	if apply_stash "[email protected]"
	then
		test -z "$unstash_index" || shift
		drop_stash "[email protected]"
	fi
	;;
308 309 310 311
branch)
	shift
	apply_to_branch "[email protected]"
	;;
しらいしななこ's avatar
しらいしななこ committed
312
*)
313
	if test $# -eq 0
314
	then
315
		save_stash &&
316
		echo '(To restore them type "git stash apply")'
317 318
	else
		usage
319 320
	fi
	;;
しらいしななこ's avatar
しらいしななこ committed
321
esac